{ 9/4/02 : Note need to add |CR to AsciiSave! }

Unit SaveFile;

Interface

Uses
  records,
  genshit,
  skaunit,
  crt,
  dos,
  control,
  xms_,
  extense,
  config;

{::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::}

Procedure eSaveMenu;
Procedure eSaveAnsi   (fileName : string);
Procedure eSaveAscii  (fileName : string);
Procedure eSaveBin    (fileName : string);
Procedure eSaveAdf    (fileName : string);
Procedure eSaveFont   (fileName : string);
Procedure eSavePal    (fileName : string);
Procedure eSavePascal (fileName : string);
Procedure eSavePipe   (fileName : string);
Procedure eSaveXBin   (fileName : string);
{::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::}
implementation
{::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::}
var eOutFile : file;
    eTextFile: text;
{::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::}
Procedure eSaveMenu;
const
 eMaxTypes  = 9;
 eType1 : array[1..eMaxTypes] of string[30] =
         (' |15A|07nsi ',' Asc|15i|07i ',' |15B|07in ',' Ar|15t|07worx ',
          ' |15X|07BiN ',' |15F|07ont ',' |15P|07alette ',' Pa|15s|07cal ',' Pip|15e ');
 eType2 : array[1..eMaxTypes] of string[30] =
         (' |15A|00nsi ',' Asc|15i|00i ',' |15B|00in ',' Ar|15t|00worx ',
          ' |15X|00BiN ',' |15F|00ont ',' |15P|00alette ',' Pa|15s|00cal ',' Pip|15e ');
 eExt   : array[1..eMaxTypes] of string[10] = ('Ansi','Ascii','Binary','Artworx','XBiN','Font','Palette','Pascal','Pipe');
 ePos   : array[1..eMaxTypes] of byte =
         (17,23,30,35,44,50,56,65,73);
var
 eFormat: byte;
 eName  : string[12];
 eFExt  : array[1..eMaxTypes] of string[3];

         Function eCheckCreate(fileName : string) : boolean;
         var eFile : file;
          begin
          assign(eFile,fileName);
          {$I-} rewrite(eFile,1); {$I+}
          if (ioResult<>0) then
           begin
           eCheckCreate := false;
           eErrorPause('Error, that file could not be created..');
           end else
            begin
            close(eFile);
            assign(eFile,fileName);
            erase(eFile);
            eCheckCreate := true;
            end;
          end;

         Procedure eSetupFileExtensions;
          begin
          eFExt[1] := eConfigData^.cAnsiExt;
          eFExt[2] := eConfigData^.cAsciiExt;
          eFExt[3] := eConfigData^.cBinExt;
          eFExt[4] := eConfigData^.cAdfExt;
          eFExt[5] := eConfigData^.cXBinExt;
          eFExt[6] := eConfigData^.cFontExt;
          eFExt[7] := eConfigData^.cPalExt;
          eFExt[8] := eConfigData^.cPascalExt;
          eFExt[9] := eConfigData^.cPipExt;
          end;

         Procedure eSelectFormat;
         var inkey : string[2];
             done  : boolean;
             bars  : array[1..2] of byte;
                x  : byte;

         Procedure eShowBars;
          begin
          gotoXY(ePos[bars[1]],1);
          skaWrite('|B0|07'+eType1[bars[1]]);
          gotoXY(ePos[bars[2]],1);
          skaWrite('|B3|00'+eType2[bars[2]]);
          end;

          begin
          window(1,1,80,25);
          clrEol;
          cursor_off;
          skaWrite('|B0|15S|07elect |15F|07ormat: ');
          bars[2] := 1;
          for x := 1 to eMaxTypes do begin bars[1] := x; eShowBars; end;
          repeat
          done := false;
          inKey := eReadKey;
          inKey[1] := upCase(inKey[1]);
          if (eMouseUsed=true) then
           case inKey[1] of
           '4' : begin
                 bars[1] := bars[2];
                 if (bars[2]<>1) then dec(bars[2]) else bars[2] := 1;
                 eShowBars;
                 end;
           '6' : begin
                 bars[1] := bars[2];
                 if (bars[2]<>eMaxTypes) then inc(bars[2]) else bars[2] := eMaxTypes;
                 eShowBars;
                 end;
           'B' : begin
                 eFormat := bars[2];
                 done := true;
                 end;
           'Q' : begin
                 eFormat := 0;
                 done := true;
                 end;
           end else
           case inKey[1] of
           'A' : begin
                 eFormat := 1;
                 done := true;
                 end;
           'I' : begin
                 eFormat := 2;
                 done := true;
                 end;
           'B' : begin
                 eFormat := 3;
                 done := true;
                 end;
           'T' : begin
                 eFormat := 4;
                 done := true;
                 end;
           'X' : begin
                 eFormat := 5;
                 done := true;
                 end;
           'F' : begin
                 eFormat := 6;
                 done := true;
                 end;
           'P' : begin
                 eFormat := 7;
                 done := true;
                 end;
           'S' : begin
                 eFormat := 8;
                 done := true;
                 end;
           'E' : begin
                 eFormat := 9;
                 done := true;
                 end;
           #13 : begin
                 eFormat := bars[2];
                 done := true;
                 end;
           #27 : begin
                 eFormat := 0;
                 done := true;
                 end;
           #0  : begin
                 inkey := eReadKeyboard;
                 case inKey[1] of
                 #75 : begin
                       bars[1] := bars[2];
                       if (bars[2]<>1) then dec(bars[2]) else bars[2] := 1;
                       eShowBars;
                       end;
                 #77 : begin
                       bars[1] := bars[2];
                       if (bars[2]<>eMaxTypes) then inc(bars[2]) else bars[2] := eMaxTypes;
                       eShowBars;
                       end;
                 end;
              end;
            end;
          if (eMouseUsed=true) then eMouseUsed := false;
          until (done=true);
          eClearMouse;
          cursor_on;
          end;

 begin
 eSetupFileExtensions;
 eSelectFormat;
 if (eFormat=0) then exit;
 gotoXY(1,1);
 textAttr := 7; clrEol;
 skaWrite('|B0|15S|07aving |15a|07s |03'+eExt[eFormat]+'|07 - |15P|07lease |15e|07nter |15f|07ilename: ');
 eName := inputStr(whereX,whereY,7,30,'');
 if (eName='') then exit;
 if (pos('.',eName)=0) then eName := eName+'.'+eFExt[eFormat];
 if (eCheckCreate(eName)=true) then
  begin
   case eFormat of
    1 : eSaveAnsi(eName);
    2 : eSaveAscii(eName);
    3 : eSaveBin(eName);
    4 : eSaveAdf(eName);
    5 : eSaveXBin(eName);
    6 : eSaveFont(eName);
    7 : eSavePal(eName);
    8 : eSavePascal(eName);
    9 : eSavePipe(eName);
   end;
  eCurrentData^.curChanges := 0;
  if (eConfigData^.cSauce=0) then
   begin
   eSauceEditor;
   eAddSauceData(eName);
   end else
  if (eConfigData^.cSauce=1) then
   begin
   gotoXY(1,1);
   textAttr := 7; clrEol;
   eClearMouse;
   skaWrite('|B0|15W|07ould |15y|07ou |15l|07ike |15t|07o |15a|07dd |03SAUCE |15d|07ata: ');
   if (eSel=true) then
    begin
    eClearMouse;
    eSauceEditor;
    eAddSauceData(eName);
    end;
   end;
  end;
  end;
{::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::}
Procedure eSaveAnsi  (fileName : string);
const eEsc    = #27+'[';
var eCurAttr  : array[1..2] of byte;
    eTmp      : array[1..160] of byte;
    eTempStr  : string;
    eCount    : longInt;
    eC2       : byte;
    eLastAttr : array[1..3] of byte;

              Procedure eAddAttribute(attr : byte);
               begin
               if (attr=eLastAttr[3]) then exit;
               eCurAttr[1] := attr mod 16;
               eCurAttr[2] := attr div 16;
               eTempStr := '';
               if (eCurAttr[1] in [08..15]) then eTempStr := eTempStr + '1;' else
                   eTempStr := eTempStr + '0;';
                 case eCurAttr[1] of
                  00,08 : eTempStr := eTempStr + '30;';
                  01,09 : eTempStr := eTempStr + '34;';
                  02,10 : eTempStr := eTempStr + '32;';
                  03,11 : eTempStr := eTempStr + '36;';
                  04,12 : eTempStr := eTempStr + '31;';
                  05,13 : eTempStr := eTempStr + '35;';
                  06,14 : eTempStr := eTempStr + '33;';
                  07,15 : eTempStr := eTempStr + '37;';
                 end;
                 case eCurAttr[2] of
                  00,08 : eTempStr := eTempStr + '40';
                  01,09 : eTempStr := eTempStr + '44';
                  02,10 : eTempStr := eTempStr + '42';
                  03,11 : eTempStr := eTempStr + '46';
                  04,12 : eTempStr := eTempStr + '41';
                  05,13 : eTempStr := eTempStr + '45';
                  06,14 : eTempStr := eTempStr + '43';
                  07,15 : eTempStr := eTempStr + '47';
                 end;
               if (eCurAttr[2] in [08..15]) then eTempStr := eTempStr + ';5';
               write(eTextFile,eEsc+eTempStr+'m');
               eLastAttr[1] := eCurAttr[1];
               eLastAttr[2] := eCurAttr[2];
               eLastAttr[3] := attr;
               end;

               Procedure eAddCharacter(ch : char);
               begin
               write(eTextFile,ch);
               end;
 begin
 assign(eTextFile,fileName);
 rewrite(eTextFile);
 gotoXY(1,1);textAttr := 7;clrEol;
 write(eTextFile,eEsc+'0m');
 skaWrite('|15W|07ould |15y|07ou |15t|07o |15i|07nsert |15c|07lear |15s|07creen |15c|07ommand: ');
 if (eSel=true) then write(eTextFile,eEsc+'2J');
  for eCount := 0 to eCurrentData^.curLength-1 do
   begin
   xmsGetDataFrom(eXmsHandle,eCount*eConfigData^.cWidth*2,160,@eTmp);
   for eC2 := 1 to 160 do
    begin
    if not odd(eC2) then
     begin
     eAddAttribute(eTmp[eC2]);
     eAddCharacter(chr(eTmp[eC2-1]));
     end;
    end;
   end;
 {::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::}
 write(eTextFile,eEsc+'0m'+#26);
 close(eTextFile);
 end;
{::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::}
Procedure eSaveAscii (fileName : string);
var count : longInt;
    count2: byte;
    tmp   : array[1..160] of char;
    str   : string[80];
    shave : boolean;
 begin
 assign(eTextFile,fileName);
 {$i-}rewrite(eTextFile);{$i+}
 if (ioResult<>0) then exit;
 for count := 0 to eCurrentData^.curLength-1 do
  begin
  fillChar(str,80,0);
  xmsGetDataFrom(eXmsHandle,count*eConfigData^.cWidth*2,160,@tmp);
  for count2 := 1 to 160 do if odd(count2) then str := str + tmp[count2];
  if ((str[80]=#32) or (str[80]=#0)) then begin
   str[0]:=#79; writeLn (eTextFile,str); end else write(eTextFile,str);
  end;
 close(eTextFile);
 end;
{::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::}
Procedure eSaveBin   (fileName : string);
var count : longInt;
    width : word;
    tmp   : array[1..(999*2)] of byte;
 begin
 gotoXY(1,1);textAttr := 7;clrEol;
 skaWrite('|15P|07lease |15e|07nter |15w|07idth |15t|07o |15s|07ave |15b|07inary |15a|07s (80-'
          +strr(eConfigData^.cWidth)+'): ');
 repeat width := str2Byte(inputStr(whereX,whereY,7,5,strr(eConfigData^.cWidth))) until (width in [80..eConfigData^.cWidth]);
 width := width*2;
 assign(eOutFile,fileName);
 rewrite(eOutFile,1);
  for count := 0 to eCurrentData^.curLength-1 do
   begin
   xmsGetDataFrom(eXmsHandle,count*eConfigData^.cWidth*2,width,@tmp);
   blockWrite(eOutFile,tmp,width);
   end;
 close(eOutFile);
 end;
{::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::}
Procedure eSaveAdf   (fileName : string);
var count : longInt;
    tmp   : array[1..(999*2)] of byte;
   width  : word;
     ver  : byte;
 begin
 ver := 1;
 gotoXY(1,1);textAttr := 7;clrEol;
 width := 160;
 assign(eOutFile,fileName);
 rewrite(eOutFile,1);
 blockWrite(eOutFile,ver,1);
 blockWrite(eOutFile,eCurrentData^.curPal,sizeOf(eCurrentData^.curPal));
 blockWrite(eOutFile,eCurrentData^.curFont,sizeOf(eCurrentData^.curFont));
 for count := 1 to eCurrentData^.curLength+1 do
  begin
  xmsGetDataFrom(eXmsHandle,pred(count)*eConfigData^.cWidth*2,width,@tmp);
  blockWrite(eOutFile,tmp,width);
  end;
 close(eOutFile);
 end;
{::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::}
Procedure eSaveFont  (fileName : string);
 begin
 assign(eOutFile,fileName);
 rewrite(eOutFile,1);
 blockWrite(eOutFile,eCurrentData^.curFont,4096);
 close(eOutFile);
 end;
{::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::}
Procedure eSavePal   (fileName : string);
 begin
 assign(eOutFile,fileName);
 rewrite(eOutFile,1);
 blockWrite(eOutFile,eCurrentData^.curPal,sizeOf(eCurrentData^.curPal));
 close(eOutFile);
 end;
{::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::}
Function eGetFormat : byte;
const
 eType1 : array[1..4] of string[15] = (' |15F|07ont ',' |15P|07alette ',' |15I|07mage ',' |15F|07ull ');
 eType2 : array[1..4] of string[15] = (' |15F|00ont ',' |15P|00alette ',' |15I|00mage ',' |15F|00ull ');
 ePos   : array[1..4] of byte = (34,40,49,56);
var
 bars   : array[1..2] of byte;
 count  : byte;
 inkey  : string[2];
 done   : boolean;

        Procedure eShowBars;
         begin
         gotoXY(ePos[bars[1]],1);
         skaWrite('|B0'+eType1[bars[1]]);
         gotoXY(ePos[bars[2]],1);
         skaWrite('|B3'+eType2[bars[2]]);
         end;

 begin
 textAttr := 7;gotoXY(1,1);clrEol;
 skaWrite('|15P|07lease |15s|07elect |15p|07ortion |15t|07o |15e|07xport: ');
 bars[2] := 1;
 for count := 1 to 4 do begin bars[1] := count; eShowBars end;
  repeat
  done := false;
  inKey := eReadKey;
  inKey := upCase(inKey[1]);
  if (eMouseUsed=true) then
   case inKey[1] of
    '6' : begin
          bars[1] := bars[2];
          if (bars[2]<>4) then inc(bars[2]);
          eShowBars;
          end;
    '4' : begin
          bars[1] := bars[2];
          if (bars[2]<>1) then dec(bars[2]);
          eShowBars;
          end;
    'B' : begin
          eGetFormat := bars[2];
          done := true;
          end;
    'Q' : begin
          eGetFormat := 0;
          done := true;
          end;
   end else
  case inKey[1] of
    #13 : begin
          eGetFormat := bars[2];
          done := true;
          end;
    #27 : begin
          eGetFormat := 0;
          done := true;
          end;
    'F' : begin
          eGetFormat := 1;
          done := true;
          end;
    'P' : begin
          eGetFormat := 2;
          done := true;
          end;
    'I' : begin
          eGetFormat := 3;
          done := true;
          end;
    'F' : begin
          eGetFormat := 4;
          done := true;
          end;
    #0  : begin
          inKey := eReadKeyboard;
           case inKey[1] of
           #77 : begin
                 bars[1] := bars[2];
                 if (bars[2]<>4) then inc(bars[2]);
                 eShowBars;
                 end;
           #75 : begin
                 bars[1] := bars[2];
                 if (bars[2]<>1) then dec(bars[2]);
                 eShowBars;
                 end;
           end;
          end;
  end;
  if (eMouseUsed=true) then eMouseUsed := false;
  until (done=true);
 eClearMouse;
 end;
{::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::}
Function eGetHandle : string;
 begin
 gotoXY(1,1);textAttr := 7;clrEol;
 skaWrite('|15P|07lease |15e|07nter |15v|07ariable |15n|07ame: ');
 eGetHandle := inputStr(whereX,whereY,7,20,'Image_Data');
 end;
{::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::}
Procedure eSavePascal(fileName : string);
var eFormat  : byte;
    eHandle  : string[20];
    eCount   : longInt;
    eTmpBuff : array[1..160] of byte;
    eByteCnt : byte;
    eTemp    : byte;
    eTmpPal  : array[1..192] of byte;
 begin
 eFormat := eGetFormat;
 if (eFormat=0) then exit;
 eHandle := eGetHandle;
 if (eHandle='') then exit;
 assign(eTextFile,fileName);
 rewrite(eTextFile);
 writeLn(eTextFile,'{::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::}');
 writeLn(eTextFile,'(**');
 writeLn(eTextFile,' ** The Empathy Experience (c) Grant Passmore (skaboy) / ACiD 1998-2003');
 writeLn(eTextFile,' ** Screen data exported by empathy ver '+eVersion);
 writeLn(eTextFile,' **');
 writeLn(eTextFile,' ** Include this into your program with the {$I} directive');
 writeLn(eTextFile,' ** Example implementations can be obtainted upon request');
 writeLn(eTextFile,' **)');
 writeLn(eTextFile,'{::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::}');
 if (eFormat=1) or (eFormat=4) then
  begin
  writeLn(eTextFile,'{ Dos VGA Font }');
  writeLn(eTextFile,eHandle+'_Font : array[1..4096] of byte = (');
  eTemp := 0;
  write(eTextFile,'  ');
  for eCount := 1 to 4095 do
   begin
   inc(eTemp);
   write(eTextFile,ePadByte(eCurrentData^.curFont[eCount])+',');
   if (eTemp>=18) then begin eTemp := 0; writeLn(eTextFile); write(eTextFile,'  ') end;
   end;
  write(eTextFile,ePadByte(eCurrentData^.curFont[4096])+');'#13#10);
  writeLn(eTextFile,'{::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::}');
  end;
 if (eFormat=2) or (eFormat=4) then
  begin
  writeLn(eTextFile,'{ Dos Color Palette }');
  writeLn(eTextFile,eHandle+'_Palette : array[1..192] of byte = (');
  move(eCurrentData^.curPal,eTmpPal,192);
  write(eTextFile,'  ');
  eTemp := 0;
  for eCount := 1 to 191 do
   begin
   inc(eTemp);
   write(eTextFile,ePadByte(eTmpPal[eCount])+',');
   if (eTemp>=18) then begin eTemp := 0; writeLn(eTextFile); write(eTextFile,'  '); end;
   end;
  write(eTextFile,ePadByte(eTmpPal[192])+');'#13#10);
  writeLn(eTextFile,'{::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::}');
  end;
 if (eFormat=3) or (eFormat=4) then
  begin
  writeLn(eTextFile,'{ Screen Image in Straight Video Memory Format }');
  writeLn(eTextFile,eHandle+'_Screen : array[1..',160*eCurrentData^.curLength,'] of byte = (');
  eTemp := 0;
  write(eTextFile,'  ');
  for eCount := 1 to eCurrentData^.curLength do
   begin
   xmsGetDataFrom(eXmsHandle,pred(eCount)*eConfigData^.cWidth*2,160,@eTmpBuff);
   if (eCount<eCurrentData^.curLength) then
   for eByteCnt := 1 to 160 do
    begin
    inc(eTemp);
    write(eTextFile,ePadByte(eTmpBuff[eByteCnt])+',');
    if (eTemp>=18) then begin eTemp := 0; writeLn(eTextFile); write(eTextFile,'  ') end;
    end else
   for eByteCnt := 1 to 159 do
    begin
    inc(eTemp);
    write(eTextFile,ePadByte(eTmpBuff[eByteCnt])+',');
    if (eTemp>=18) then begin eTemp := 0; writeLn(eTextFile); write(eTextFile,'  ') end;
    end;
   end;
  write(eTextFile,ePadByte(eTmpBuff[160])+');');
  end;
 close(eTextFile);
 end;
{::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::}
Procedure eSavePipe   (fileName : string);
var eTmpBuff  : array[1..160] of byte;
    eLineNum  : longInt;
    eLastAttr : byte;
    eCount    : byte;

    Procedure eAddPipeCode(eChar,eAttr : byte);
    var eAttrHalf : array[1..2] of byte;
     begin
     if (eLastAttr<>eAttr) then
      begin
      eAttrHalf[1] := (eAttr mod 16);
      eAttrHalf[2] := (eAttr div 16);
      if (eAttrHalf[1]<>(eLastAttr mod 16)) then write(eTextFile,'|'+eTabWord(eAttrHalf[1],2));
      if (eAttrHalf[2]<>(eLastAttr div 16)) then write(eTextFile,'|B',eAttrHalf[2]);
      end;
     write(eTextFile,chr(eChar));
     eLastAttr := eAttr;
     end;

 begin
 assign(eTextFile,fileName);
 rewrite(eTextFile);
 eLastAttr := 7;
 for eLineNum := 1 to eCurrentData^.curLength do
  begin
  xmsGetDataFrom(eXmsHandle,pred(eLineNum)*eConfigData^.cWidth*2,160,@eTmpBuff);
  for eCount := 1 to 160 do if (odd(eCount)=true) then eAddPipeCode(eTmpBuff[eCount],eTmpBuff[eCount+1]);
  write(eTextFile,'|CR');
  end;
 close(eTextFile);
 end;
{::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::}
Procedure eSaveXBin  (fileName : string);
const eColor  : array[0..15] of byte = (0,1,2,3,4,5,20,7,56,57,58,59,60,61,62,63);
var   eTmpPal : array[0..15,1..3] of byte;
      eCount  : array[1..2] of longInt;
      eHeader : eXBinRec;
      eBuffer : array[0..(999*2)] of byte;
 begin
 gotoXY(1,1); textAttr := 7; clrEol;
 skaWrite('|15P|07lease |15e|07nter |15w|07idth |15t|07o |15s|07ave |07XB|15i|07N |15a|07s (80-'
          +strr(eConfigData^.cWidth)+'): ');
 repeat eHeader.eWidth := str2Byte(inputStr(whereX,whereY,7,5,strr(eConfigData^.cWidth))) until (eHeader.eWidth in
        [80..eConfigData^.cWidth]);
 eHeader.eBinID    := 'XBIN';
 eHeader.eEofMark  := #26;
 eHeader.eHeight   := eCurrentData^.curLength;
 eHeader.eFontSize := 16;
 eHeader.eFlags    := $b;
 assign(eOutFile,fileName);
 rewrite(eOutFile,1);
 blockWrite(eOutFile,eHeader,11);
 for eCount[1] := 0 to 15 do { move pal data to xbin 0..15 straight format }
  for eCount[2] := 1 to 3 do eTmpPal[eCount[1],eCount[2]] := eCurrentData^.curPal[eColor[eCount[1]],eCount[2]];
 blockWrite(eOutFile,eTmpPal,sizeOf(eTmpPal));
 blockWrite(eOutFile,eCurrentData^.curFont,4096);
 fillChar(eBuffer,sizeOf(eBuffer),0);
 for eCount[1] := 1 to eCurrentData^.curLength do
  begin
  xmsGetDataFrom(eXmsHandle,pred(eCount[1])*eConfigData^.cWidth*2,eHeader.eWidth*2,@eBuffer);
  blockWrite(eOutFile,eBuffer,eHeader.eWidth*2);
  end;
 close(eOutFile);
 end;

{::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::}

begin
end.